#include "AnimGraph/AnimGraphEditor.h"
#include "catch.hpp"

TEST_CASE("Node Socket To InputPin Conversion", "[animGraphEditor]") {
  int node_index = 321;
  int socket_index = 221;
  long socket_id;

  socket_id = NodeIndexAndSocketIndexToInputPinId(node_index, socket_index);

  int node_index_resolved;
  int socket_index_resolved;

  InputPinIdToNodeIndexAndSocketIndex(
      socket_id,
      &node_index_resolved,
      &socket_index_resolved);

  CHECK(node_index == node_index_resolved);
  CHECK(socket_index == socket_index_resolved);
}

TEST_CASE("Node Socket To OutputPin Conversion", "[animGraphEditor]") {
  int node_index = 321;
  int socket_index = 221;
  long socket_id;

  socket_id = NodeIndexAndSocketIndexToOutputPinId(node_index, socket_index);

  int node_index_resolved;
  int socket_index_resolved;

  OutputPinIdToNodeIndexAndSocketIndex(
      socket_id,
      &node_index_resolved,
      &socket_index_resolved);

  CHECK(node_index == node_index_resolved);
  CHECK(socket_index == socket_index_resolved);
}